#include <stdio.h>

void hexdump(FILE *f, void *buf, int n) {
	int i;
	char line[80];
	for (i = 0; i < n; i++) {
		char txt[4];
		unsigned char c = *(((char*) buf)+i);
		int ix = i % 16;
		if (ix == 0) {
			sprintf(line, "%8.8x", i);
			memset(line+8, ' ', 50);
			memset(line+58, '.', 16);
			line[74] = '\n';
			line[75] = '\0';
		}
		sprintf(txt, " %2.2x", (unsigned int) c);
		memcpy(line+8+3*ix, txt, 3); 
		if (isprint(c)) 
			line[58+(i%16)] = c;
		if (ix == 15 || i == n-1)
			fputs(line, f);
	}
}

